Package org.eclipse.emf.cdo.server

# Class CDOServerExporter<OUT>

java.lang.Object
org.eclipse.emf.cdo.server.CDOServerExporter<OUT>

Direct Known Subclasses:
  `CDOServerExporter.Binary`, `CDOServerExporter.XML`

public abstract class CDOServerExporter<OUT> extends Object
Exports the complete contents of a `repository` in a format suitable for `imports` into new repositories.

Subtypes specify the actual exchange format.

Since:
  4.0
Author:
  Eike Stepper

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`CDOServerExporter.Binary`
`static interface`
`CDOServerExporter.BinaryConstants`
Binary constants being used by both `exporters` and `importers`.
`static final class`
`CDOServerExporter.Statistics`
`static class`
`CDOServerExporter.XML`
An `exporter` that creates XML output suitable to be interpreted by an `XML importer`.
`static interface`
`CDOServerExporter.XMLConstants`
XML constants being used by both `exporters` and `importers`.

## Constructor Summary

Constructors
Constructor
Description
`CDOServerExporter(IRepository repository)`

## Method Summary

Modifier and Type
Method
Description
`protected abstract OUT`
`createOutput(OutputStream out)`
`protected abstract void`
`endPackageUnit(OUT out)`
`protected void`
`exportAll(OUT out)`
`protected void`
`exportBranch(OUT out, CDOBranch branch)`
`protected void`
`exportBranches(OUT out)`
`protected abstract void`
`exportCommit(OUT out, CDOCommitInfo commitInfo)`
`protected void`
`exportCommits(OUT out)`
`protected void`
`exportLobs(OUT out)`
`protected abstract void`
`exportPackageInfo(OUT out, String packageURI)`
`protected void`
`exportPackages(OUT out)`
`final void`
`exportRepository(OutputStream out)`
`protected abstract void`
`exportRevision(OUT out, CDORevision revision)`
`protected void`
`exportRevisions(OUT out, CDOBranch branch)`
`String`
`getBranchPath()`
`final IRepository`
`getRepository()`
`CDOServerExporter.Statistics`
`getStatistics()`
`long`
`getTimeStamp()`
`boolean`
`isExportSystemPackages()`
`void`
`setBranchPath(String branchPath)`
`void`
`setExportSystemPackages(boolean exportSystemPackages)`
`void`
`setTimeStamp(long timeStamp)`
`protected abstract OutputStream`
`startBlob(OUT out, byte[] id, long size)`
`protected abstract Writer`
`startClob(OUT out, byte[] id, long size)`
`protected abstract void`
`startPackageUnit(OUT out, String id, CDOPackageUnit.Type type, long time, String data)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### CDOServerExporter

public CDOServerExporter(IRepository repository)

## Method Details

### getRepository

public final IRepository getRepository()

### getStatistics

public CDOServerExporter.Statistics getStatistics()

Since:
  4.8

### isExportSystemPackages

public boolean isExportSystemPackages()

Since:
  4.7

### setExportSystemPackages

public void setExportSystemPackages(boolean exportSystemPackages)

Since:
  4.7

### getBranchPath

public String getBranchPath()

Since:
  4.8

### setBranchPath

public void setBranchPath(String branchPath)

Since:
  4.8

### getTimeStamp

public long getTimeStamp()

Since:
  4.8

### setTimeStamp

public void setTimeStamp(long timeStamp)

Since:
  4.8

### exportRepository

public final void exportRepository(OutputStream out) throws Exception

Throws:
  `Exception`

### createOutput

protected abstract OUT createOutput(OutputStream out) throws Exception

Throws:
  `Exception`

### exportAll

protected void exportAll(OUT out) throws Exception

Throws:
  `Exception`

### exportPackages

protected void exportPackages(OUT out) throws Exception

Throws:
  `Exception`

### startPackageUnit

protected abstract void startPackageUnit(OUT out, String id, CDOPackageUnit.Type type, long time, String data) throws Exception

Throws:
  `Exception`

### endPackageUnit

protected abstract void endPackageUnit(OUT out) throws Exception

Throws:
  `Exception`

### exportPackageInfo

protected abstract void exportPackageInfo(OUT out, String packageURI) throws Exception

Throws:
  `Exception`

### exportBranches

protected void exportBranches(OUT out) throws Exception

Throws:
  `Exception`

### exportBranch

protected void exportBranch(OUT out, CDOBranch branch) throws Exception

Throws:
  `Exception`

### exportRevisions

protected void exportRevisions(OUT out, CDOBranch branch) throws Exception

Throws:
  `Exception`

### exportRevision

protected abstract void exportRevision(OUT out, CDORevision revision) throws Exception

Throws:
  `Exception`

### exportLobs

protected void exportLobs(OUT out) throws Exception

Throws:
  `Exception`

### startBlob

protected abstract OutputStream startBlob(OUT out, byte[] id, long size) throws Exception

Throws:
  `Exception`

### startClob

protected abstract Writer startClob(OUT out, byte[] id, long size) throws Exception

Throws:
  `Exception`

### exportCommits

protected void exportCommits(OUT out) throws Exception

Throws:
  `Exception`

### exportCommit

protected abstract void exportCommit(OUT out, CDOCommitInfo commitInfo) throws Exception

Throws:
  `Exception`